Loading...
Searching...
No Matches
SmtpClient::SmtpConnection Class Reference

class for SMTP connections; returns an object of class SmtpClient for sending emails More...

Inherits ConnectionProvider::AbstractConnectionWithInfo.

## Public Member Functions

| constructor (string name, string description, string url, hash< auto > attributes={}, hash< auto > options={})
| creates the SmtpConnection connection object
DataProvider::AbstractDataProvider | getDataProvider ()
| returns an SmtpClientDataProvider object for this connection
*hash< auto > | getRuntimeOptions ()
| returns runtime options
string | getType ()
| returns `"smtp"`
bool | hasDataProvider ()
| returns True, as the connection returns a data provider with the getDataProvider() method
Qore::AbstractPollOperation | startPollConnect ()
| Called to start a non-blocking polling ping operation on the remote SMTP server.
bool | supportsPollingApi ()
| returns True, since this connection type supports the Qore Socket-based polling API

## Public Attributes

const | ConnectionScheme
| Connection entry info.

## Protected Member Functions

hash< ConnectionSchemeInfo > | getConnectionSchemeInfoImpl ()
| Returns the ConnectionSchemeInfo hash for this object.
SmtpClient | getImpl (bool connect=True, *hash< auto > rtopts)
| returns an SmtpClient object
| setChildCapabilities ()
| Sets child data provider capabilities.

## Detailed Description

class for SMTP connections; returns an object of class SmtpClient for sending emails

supports the following runtime options in getImpl() for connection logging:

- `"log"`: a closure accepting a single string for logging
- `"dbglog"`: a closure taking a single string for detailed technical connection logging

Since
  SmtpClient 1.6

## Member Function Documentation

## constructor()

SmtpClient::SmtpConnection::constructor | ( | string | name,
|  | string | description,
|  | string | url,
|  | hash< auto > | attributes = `{}`,
|  | hash< auto > | options = `{}`
| ) |  |

creates the SmtpConnection connection object

Parameters

  name | the name of the connection
  description | connection description
  url | connection URL (potentially with password info)
  attributes | various attributes. See below
  options | connection options

See AbstractConnection::constructor() for `attributes` and `options` reference.

Exceptions

  CONNECTION-OPTION-ERROR | missing or invalid connection option

## getDataProvider()

DataProvider::AbstractDataProvider SmtpClient::SmtpConnection::getDataProvider | ( |  | ) |

returns an SmtpClientDataProvider object for this connection

Returns
  an SmtpClientDataProvider object for this connection

See also
  hasDataProvider()

## getImpl()

SmtpClient SmtpClient::SmtpConnection::getImpl | ( | bool | connect = `True`,
|  | *hash< auto > | rtopts
| ) |  |

protected

returns an SmtpClient object

Parameters

  connect | if True, then SmtpClient::connect() is called

  rtopts

  supports the following runtime options in getImpl() for connection logging:
  - `"log"`: a closure accepting a single string for logging
  - `"dbglog"`: a closure taking a single string for detailed technical connection logging

Returns
  an SmtpClient object

## getRuntimeOptions()

*hash< auto > SmtpClient::SmtpConnection::getRuntimeOptions | ( |  | ) |

returns runtime options

Returns
  a hash with the following keys reflecting support for the corresponding runtime options in getImpl() for connection logging:
  - `"log"`: a closure accepting a single string for logging
  - `"dbglog"`: a closure taking a single string for detailed technical connection logging

## hasDataProvider()

bool SmtpClient::SmtpConnection::hasDataProvider | ( |  | ) |

returns True, as the connection returns a data provider with the getDataProvider() method

Returns
  True, as the connection returns a data provider with the getDataProvider() method

See also
  getDataProvider()

## startPollConnect()

Qore::AbstractPollOperation SmtpClient::SmtpConnection::startPollConnect | ( |  | ) |

Called to start a non-blocking polling ping operation on the remote SMTP server.

Returns
  a socket poll operation object that will allow the connection goal to be reached with polling

See also
  supportsPollingApi()

Since
  SmtpClient 2.0

## supportsPollingApi()

bool SmtpClient::SmtpConnection::supportsPollingApi | ( |  | ) |

returns True, since this connection type supports the Qore Socket-based polling API

Returns
  True

Since
  ConnectionProvider 1.7